﻿using System.Data;
using System.Data.SQLite;
using System.Diagnostics;
using System.Media;
using VoicevoxCoreNet;

namespace LLM_Doghouse
{
    public partial class EditChatForm : Form
    {
        private string DatabasePath;
        private int intNo;
        private string strNam;
        private string strSys = "";
        private int intCtx = 0;
        private float fltTmp = 0;
        private int intGpu = 0;
        private string strMdl = "";
        private int intSyt = 0;
        private string strCvo = "";
        private int intVvx = 0;
        private bool booBot = false;
        private string strTkn = "";
        private ulong lngCid = 0;
        private string strUsu = "";
        private string strSml = "";
        private string strAfc = "";
        private string strSkp = "";
        private string strCnc = "";
        private string strNeg = "";
        //VOICEVOX
        private uint intSpeaker = 0;
        private Core core;

        public EditChatForm(string DatabasePath, int intNo)
        {
            InitializeComponent();
            this.DatabasePath = DatabasePath;
            this.intNo = intNo;
        }
        private DataTable syt()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from syt order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable cvo()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from cvo order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable vvx()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from vvx order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }

        private void EditChatForm_Load(object sender, EventArgs e)
        {
            InitSetting();

            txtNo.Text = intNo.ToString();
            if (intNo == 0)
            {
                btnUpd.Enabled = false;
                chkDel.Enabled = false;
                btnDh.Enabled = false;
            }
        }

        private void InitSetting()
        {
            try
            {
                cboSyt.DataSource = syt();
                cboCvo.DataSource = cvo();
                cboVvx.DataSource = vvx();

                picUsu.ImageLocation = "imgUsu.png";
                picSml.ImageLocation = "imgSml.png";
                picAfc.ImageLocation = "imgAfc.png";
                picSkp.ImageLocation = "imgSkp.png";
                picCnc.ImageLocation = "imgCnc.png";
                picNeg.ImageLocation = "imgNeg.png";

                picUsu.AllowDrop = true;
                picSml.AllowDrop = true;
                picAfc.AllowDrop = true;
                picSkp.AllowDrop = true;
                picCnc.AllowDrop = true;
                picNeg.AllowDrop = true;

                if (intNo == 0)
                {
                    AddcolMng();
                    AddcolMng2();
                    return;
                }
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                bool dc = true;
                bool em = true;
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"select * from mng where no={intNo}";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtNam.Text = reader["nam"].ToString();
                            txtSys.Text = reader["sys"].ToString();
                            txtCtx.Text = reader["ctx"].ToString();
                            txtTmp.Text = reader["tmp"].ToString();
                            txtGpu.Text = reader["gpu"].ToString();
                            txtMdl.Text = reader["mdl"].ToString();
                            cboSyt.SelectedValue = reader["syt"];
                            cboCvo.SelectedValue = reader["cvo"];
                            cboVvx.SelectedValue = reader["vvx"];
                            if (reader.FieldCount >10)
                            {
                                chkBot.Checked = reader["bot"].ToString() == "1" ? true : false;
                                txtTkn.Text = reader["tkn"].ToString();
                                txtCid.Text = reader["cid"].ToString();
                            }
                            else dc = false;

                            if (reader.FieldCount >13)
                            {
                                if (reader["usu"].ToString() != "") picUsu.ImageLocation = reader["usu"].ToString();
                                if (reader["sml"].ToString() != "") picSml.ImageLocation = reader["sml"].ToString();
                                if (reader["afc"].ToString() != "") picAfc.ImageLocation = reader["afc"].ToString();
                                if (reader["skp"].ToString() != "") picSkp.ImageLocation = reader["skp"].ToString();
                                if (reader["cnc"].ToString() != "") picCnc.ImageLocation = reader["cnc"].ToString();
                                if (reader["neg"].ToString() != "") picNeg.ImageLocation = reader["neg"].ToString();
                            }
                            else em = false;
                        }
                    }
                }
                con.Close();
                if (!dc)  AddcolMng();
                if (!em) AddcolMng2();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        private bool CheckItem()
        {
            //パラメータチェック
            strNam = txtNam.Text;
            if (strNam.IndexOf("\'")>0 || strNam.IndexOf("\"")>0)
            {
                MessageBox.Show("Chat name contains characters that cannot be used.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return (true);
            }
            strSys = txtSys.Text;
            if (strSys.IndexOf("\'")>0 || strSys.IndexOf("\"")>0)
            {
                MessageBox.Show("System Prompt contains characters that cannot be used.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return (true);
            }
            strMdl = txtMdl.Text;
            if (strMdl.IndexOf("\'")>0 || strMdl.IndexOf("\"")>0)
            {
                MessageBox.Show("LLM Path contains characters that cannot be used.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return (true);
            }
            if (!int.TryParse(txtCtx.Text, out intCtx)) intCtx = 512;
            if (intCtx == 0) intCtx = 512;
            if (!float.TryParse(txtTmp.Text, out fltTmp)) fltTmp = 0.5f;
            if (fltTmp == 0) fltTmp = 0.5f;
            if (!int.TryParse(txtGpu.Text, out intGpu)) intGpu = 5;
            if (intGpu == 0) intGpu = 5;

            txtCtx.Text = intCtx.ToString();
            txtTmp.Text = fltTmp.ToString("0.0");
            txtGpu.Text = intGpu.ToString();

            if (!File.Exists(strMdl))
            {
                MessageBox.Show("LLM Model file does not exist.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return (true);
            }
            booBot = chkBot.Checked;
            if (booBot)
            {
                if (txtTkn.Text == "")
                {
                    MessageBox.Show("Discord Token contains characters that cannot be used.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return (true);
                }
            }

            intSyt = int.Parse(cboSyt.SelectedValue.ToString());
            strCvo = cboCvo.SelectedValue.ToString();
            intVvx = int.Parse(cboVvx.SelectedValue.ToString());
            strTkn = txtTkn.Text;
            if (!ulong.TryParse(txtCid.Text, out lngCid)) lngCid = 0;
            txtCid.Text = lngCid.ToString();
            chkBot.Checked = booBot;
            strUsu = picUsu.ImageLocation;
            if (strUsu != "") if (!File.Exists(strUsu)) strUsu = "";
            strSml = picSml.ImageLocation;
            if (strSml != "") if (!File.Exists(strSml)) strSml = "";
            strAfc = picAfc.ImageLocation;
            if (strAfc != "") if (!File.Exists(strAfc)) strAfc = "";
            strSkp = picSkp.ImageLocation;
            if (strSkp != "") if (!File.Exists(strSkp)) strSkp = "";
            strCnc = picCnc.ImageLocation;
            if (strCnc != "") if (!File.Exists(strCnc)) strCnc = "";
            strNeg = picNeg.ImageLocation;
            if (strNeg != "") if (!File.Exists(strNeg)) strNeg = "";
            return (false);
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            string strFolder = "";
            if (txtMdl.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors";
            string strRtn = OpenFile(strFolder, "Open Model File", txtMdl.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl.Text = strRtn;
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            if (CheckItem()) return;
            if (MessageBox.Show("Add a new record. Are you sure?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No) return;
            //sql編集
            string strSql = "insert into mng(tmp,gpu,ctx,sys,nam,syt,cvo,vvx,mdl,bot,tkn,cid,usu,sml,afc,skp,cnc,neg) values(" +
                            $"{fltTmp}," +
                            $"{intGpu}," +
                            $"{intCtx}," +
                            $"'{strSys}'," +
                            $"'{strNam}'," +
                            $"{intSyt}," +
                            $"'{strCvo}'," +
                            $"{intVvx}," +
                            $"'{strMdl}'," +
                            $"{(booBot ? 1 : 0)}," +
                            $"'{strTkn}'," +
                            $"'{lngCid}'," +
                            $"'{strUsu}'," +
                            $"'{strSml}'," +
                            $"'{strAfc}'," +
                            $"'{strSkp}'," +
                            $"'{strCnc}'," +
                            $"'{strNeg}')";
            this.DialogResult = DialogResult.OK;
            if (ExcSql(strSql)) this.Close();
        }

        private void btnUpd_Click(object sender, EventArgs e)
        {
            if (chkDel.Checked)
            {
                if (MessageBox.Show("Delete record. Are you sure?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No) return;
                string strSql = $"delete from mng where no={intNo}";
                this.DialogResult = DialogResult.OK;
                if (!ExcSql(strSql)) return;
                strSql = $"drop table ch{intNo}";
                ExcSql(strSql, false);
                this.Close();
            }
            else
            {
                string strTable = $"ch{intNo}";
                if (CheckItem()) return;
                if (MessageBox.Show("Update record. Are you sure?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No) return;
                string strSql = "update mng set " +
                                $"tmp={fltTmp}," +
                                $"gpu={intGpu}," +
                                $"ctx={intCtx}," +
                                $"sys='{strSys}'," +
                                $"nam='{strNam}'," +
                                $"syt={intSyt}," +
                                $"cvo='{strCvo}'," +
                                $"vvx={intVvx}," +
                                $"mdl='{strMdl}'," +
                                $"bot={(booBot ? 1 : 0)}," +
                                $"tkn='{strTkn}'," +
                                $"cid='{lngCid}'," +
                                $"usu='{strUsu}'," +
                                $"sml='{strSml}'," +
                                $"afc='{strAfc}'," +
                                $"skp='{strSkp}'," +
                                $"cnc='{strCnc}'," +
                                $"neg='{strNeg}'" +
                                $" where no={intNo}";
                this.DialogResult = DialogResult.OK;
                if (ExcSql(strSql)) this.Close();
            }
        }

        private bool ExcSql(string strSql, bool Mb = true)
        {
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = strSql;
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
                return true;
            }
            catch (Exception ex)
            {
                if (Mb) MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }

        private string OpenFile(string strFolder, string strTitle, string strInitFile, string strFilter)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.FileName = strInitFile;
            dialog.InitialDirectory = strFolder;
            dialog.FilterIndex = 2;
            dialog.Title = strTitle;
            dialog.RestoreDirectory = true;
            dialog.CheckFileExists = true;
            dialog.CheckPathExists = true;
            dialog.Filter = strFilter;
            if (dialog.ShowDialog() == DialogResult.OK) return (dialog.FileName);
            return ("");
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void txtNam_Enter(object sender, EventArgs e)
        {
            txtNam.SelectAll();
        }

        private void txtCtx_Enter(object sender, EventArgs e)
        {
            txtCtx.SelectAll();
        }

        private void txtTmp_Enter(object sender, EventArgs e)
        {
            txtTmp.SelectAll();
        }

        private void txtGpu_Enter(object sender, EventArgs e)
        {
            txtGpu.SelectAll();
        }

        private void txtMdl_Enter(object sender, EventArgs e)
        {
            txtMdl.SelectAll();
        }

        private void btnVvx_Click(object sender, EventArgs e)
        {
            if (uint.Parse(cboVvx.SelectedValue.ToString()) != intSpeaker)
            {
                intSpeaker = uint.Parse(cboVvx.SelectedValue.ToString());
                InitVoicevox();
            }
            Voicevox($"おはよう、こんにちは、こんばんは");
        }

        private void btnCvo_Click(object sender, EventArgs e)
        {
            CevioAI($"おはよう、こんにちは、こんばんは");
        }

        private void AddcolMng()
        {
            ExcSql($"Alter Table mng ADD COLUMN \"bot\" INTEGER DEFAULT 0", false);
            ExcSql($"Alter Table mng ADD COLUMN \"tkn\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"cid\" TEXT DEFAULT \"0\"", false);
        }
        private void AddcolMng2()
        {

            ExcSql($"Alter Table mng ADD COLUMN \"usu\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"sml\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"afc\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"skp\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"cnc\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"neg\" TEXT DEFAULT \"\"", false);
        }


        private void InitVoicevox()
        {
            MainForm me = new MainForm();
            core = me.GetDefaultCoreObject();
            core.LoadModel(intSpeaker);
        }


        private void Voicevox(string strMsg)
        {
            try
            {
                //MainForm me = new MainForm();
                //Core core = me.GetDefaultCoreObject();
                //core.LoadModel(intSpeaker);
                AudioQueryOptions audioQueryOptions = new AudioQueryOptions()
                {
                    kana = false
                };
                bool enableInterrogativeUpspeak = false;
                string json = core.AudioQuery(strMsg, intSpeaker, audioQueryOptions);
                SynthesisOptions synthesisOptions = new SynthesisOptions()
                {
                    enable_interrogative_upspeak = enableInterrogativeUpspeak
                };
                // When
                byte[] wavData = core.Synthesis(json, intSpeaker, synthesisOptions);
                MemoryStream ms = new MemoryStream(wavData);
                {
                    var player = new SoundPlayer(ms);
                    player.PlaySync();
                    ms.Dispose();
                    ms = null;
                }
                return;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        public void CevioAI(string strMsg)
        {
            try
            {
                dynamic service = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.ServiceControl2V40"));
                service.StartHost(false);
                dynamic talker = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.Talker2V40"));
                talker.Cast = cboCvo.SelectedValue.ToString();
                dynamic result = talker.Speak(strMsg);
                result.Wait();
                //開放忘れるとメモリリーク
                System.Runtime.InteropServices.Marshal.ReleaseComObject(talker);
                System.Runtime.InteropServices.Marshal.ReleaseComObject(service);
                return;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnDh_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to delete your chat history?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question)==DialogResult.No) return;
            string strSql = $"drop table ch{intNo}";
            ExcSql(strSql, false);
        }

        private void picUsu_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picUsu.ImageLocation != "") strFolder = Path.GetDirectoryName(picUsu.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picUsu.ImageLocation, strFilter);
            if (strRtn != "") picUsu.ImageLocation = strRtn;
        }

        private void picSml_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picSml.ImageLocation != "") strFolder = Path.GetDirectoryName(picSml.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picSml.ImageLocation, strFilter);
            if (strRtn != "") picSml.ImageLocation = strRtn;
        }

        private void picAfc_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picAfc.ImageLocation != "") strFolder = Path.GetDirectoryName(picAfc.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picAfc.ImageLocation, strFilter);
            if (strRtn != "") picAfc.ImageLocation = strRtn;
        }

        private void picSkp_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picSkp.ImageLocation != "") strFolder = Path.GetDirectoryName(picSkp.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picSkp.ImageLocation, strFilter);
            if (strRtn != "") picSkp.ImageLocation = strRtn;
        }

        private void picCnc_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picCnc.ImageLocation != "") strFolder = Path.GetDirectoryName(picCnc.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picCnc.ImageLocation, strFilter);
            if (strRtn != "") picCnc.ImageLocation = strRtn;
        }

        private void picNeg_DoubleClick(object sender, EventArgs e)
        {
            string strFolder = "";
            if (picNeg.ImageLocation != "") strFolder = Path.GetDirectoryName(picNeg.ImageLocation);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", picNeg.ImageLocation, strFilter);
            if (strRtn != "") picNeg.ImageLocation = strRtn;
        }

        private void picture_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effect = DragDropEffects.Copy;
        }

        private void picUsu_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picUsu.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picSml_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSml.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picAfc_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picAfc.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picSkp_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSkp.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picCnc_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picCnc.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picNeg_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picNeg.ImageLocation = strFiles[0];
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

    }
}
